﻿using Prism.Ioc;
using Prism.Regions;
using System.Text.Json;
using System.Windows;
using Txgy.FilesWatcher.model;
using Txgy.FilesWatcher.ViewModels;
using Txgy.FilesWatcher.Views;

namespace Txgy.FilesWatcher
{
    /// <summary>
    /// Interaction logic for App.xaml
    /// </summary>
    public partial class App
    {
        protected override Window CreateShell()
        {
            return Container.Resolve<MainWindow>();
        }

        protected override void RegisterTypes(IContainerRegistry containerRegistry)
        {
            containerRegistry.RegisterSingleton<WebsocketClient>();

            containerRegistry.RegisterSingleton<SystemConfig>(a=> 
             {
                string str = System.IO.File.ReadAllText("systemconfig.json");               
                return JsonSerializer.Deserialize<SystemConfig>(str, new JsonSerializerOptions
                {
                    ReadCommentHandling = JsonCommentHandling.Skip
                });
            });
            containerRegistry.RegisterDialog<ManualModeDialog>();
            containerRegistry.RegisterSingleton<ManualModeDialogViewModel>();
            var iregion= Container.Resolve<IRegionManager>();
            iregion.RegisterViewWithRegion("MainContentRegion", typeof(MainView)); 
        }


    }
}
